//This class copes with strings that are lists in a Prolog way,
//i.e. of the kind [string1,'string with "[]" and "," in single quotes',[substring1,substring2],string3]
//IMPORTANT: Backspace combinations like "\'" are not recognized as single quotes, so single quotes cant be used!
import java.util.Stack;

public class ListToken{

private String me;

public ListToken(String me){
this.me=me;
}

public String getMe(){
return me;
}

public boolean isEmpty(){
return (me.startsWith("]")||me==""||me.equals("[")||me.equals("[]"));
}

public boolean isList(){
return (me.startsWith("[")||isEmpty());
}

public ListToken head(){
if(!isList()) return null;
String temp=me.substring(1);
String result="";
boolean done=false;
Stack limit=new Stack();
String first;
while(!done){
  if(temp.length()==0)
    return null;   //Syntax error, maybe one should be thrown here...
  first=temp.substring(0,1);
  temp=temp.substring(1);
  if((!limit.empty())&&((String)(limit.peek())).equals("'")){
    if(first.equals("'"))
      {
      limit.pop();
      result=result.concat(first);
      }
    else
      result=result.concat(first);
    }
  else{
    if(first.equals("'"))
      {
      limit.push(first);
      result=result.concat(first);
      first="";
      }
    else{
      if(first.equals("["))
        limit.push(first);
      else{
        if((first.equals("]"))&&(!limit.empty()))
          {
          limit.pop();
          result=result.concat(first);
          first="";
          }
        }
      if((first.equals(",")||first.equals("]"))&&(limit.empty()))
        done=true;
      else
        result=result.concat(first);
      }
    }
  }
return new ListToken(result);
}

public String toString(){
return me;
}

public ListToken tail(){
if(isEmpty())
  return null;      //maybe throw errors here?
if(!isList())
  return null;      //maybe throw errors here?
String head=head().getMe();
return new ListToken("["+me.substring(head.length()+2));
}

}
